

#include <JTC\JTC.h>
#include "..\libreria\cout.h"

// scegliere la versione per la classe Spogliatoio
//#include "spogliatoioconstarv.h"
#include "spogliatoiosenzastarv.h"

Spogliatoio sp;

// modalit d'uso: accesso alla risorsa spogliatoio in modalit Maschietto con
// occupaDocciaMaschio e liberaDocciaMaschio. occupaDocciaMaschio ritorna l'"handle" della
// doccia occupata. Indicare l'"handle" della risorsa da liberare in liberaDocciaMaschio.
// uso simmetrico in modalit Femminuccia.

// Soluzione per il caso in cui non ci sono panchine a sedere nello spogliatoio (tutti aspettano fuori)

class Maschietto : public JTCThread

{
	virtual void run()
	{
		while (true) {
			// ...
			int doccia = sp.occupaDocciaMaschio();
			// ...
			sp.liberaDocciaMaschio(doccia);
		}
	}
};

class Femminuccia : public JTCThread

{
	virtual void run()
	{
		while (true) {
			// ...
			int doccia = sp.occupaDocciaFemmina();
			// ...
			sp.liberaDocciaFemmina(doccia);
		}
	}
};

void main()
{
	// da riempire a cura dello studente
}




